// Generic HTTP request object; uses AJAX to make an HTTP request
function HTTPRequest(method, mimeType) {
  this.method = method;
  this.url = "";
  this.queryString = null;
  this.callback = false;
  // This object holds the HTTP request object
  this.request = false;
  if (mimeType == "") mimeType = "text/xml";
  // Create the HTTP request object (Mozilla, etc.)
  if (window.XMLHttpRequest) {
    this.request = new XMLHttpRequest();
    if (this.request.overrideMimeType) this.request.overrideMimeType(mimeType);
  }
  // Internet Explorer
  else if (window.ActiveXObject) {
    try {
      this.request = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch(e) {
      try {
        this.request = new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch (e) {}
    }
  }
  // If we were unable to request the object, return an error
  if (!this.request) return(false);
}
  
HTTPRequest.prototype.send = function() {
  // Make the request
  if ((this.url == "") || (this.method == "")) return(false);
  this.request.onreadystatechange = this.callback;
  if (this.method == "GET") this.url += "?" + this.queryString;
  this.request.open(this.method, this.url, true);
  if (this.method == "POST") {
    this.request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    this.request.send(this.queryString);
  }
  else this.request.send(null);
  //alert("Sent: " + this.method + " " + this.url + "?" + this.queryString);
  return(true);
}
