<?php

/* smart.lib.php
   Defines a class that implements a version of the Smarty templating engine.
   Part of Siteation.
   Siteation copyright (C) 2005 Studio 703.  All rights reserved.
*/

require_once("smarty/libs/Smarty.class.php");
require_once("site.error.php");
require_once("misc.lib.php");
require_once("block.LIVEDATA.php");

class SMART_SITE extends Smarty {
  // Constructor
  function SMART_SITE() {
    // Call the parent constructor first
    parent::__construct();
    // Set the left and right delimiters
    $this->left_delimiter = "[ ";
    $this->right_delimiter = " ]";
    // Register a block function that prevents caching of parts of a template
    $this->register_block("LIVEDATA", "LiveData", FALSE);
    // Register the "explode" modifier
    $this->register_modifier("explode", "explode");
    // Register the strpos() modifier
    $this->register_modifier("indexOf", "strpos");
    // Register the urlencode() modifier
    $this->register_modifier("urlencode", "urlencode");
    $this->register_modifier("urldecode", "urldecode");
    // Register the explode_assoc() modifier
    $this->register_modifier("explode_assoc", "explode_assoc");
    // Register the plural() modifier
    $this->register_modifier("plural", "Plural");
    // Register the RFC822Timestamp modifier
    $this->register_modifier("RFC822Timestamp", "RFC822Timestamp");
    // Register the Timestamp modifier
    $this->register_modifier("Timestamp", "Timestamp");
    // Register the Summarize modifier
    $this->register_modifier("summarize", "Summarize");
    // Register the Quote modifier
    $this->register_modifier("quote", "Quote");
    // Assign the BROWSER variable
    global $_BROWSER;
    $this->assign("Browser", $_BROWSER);
    // Assign the BaseURL variable
    $this->assign("BaseURL", "http://".$_SERVER["SERVER_NAME"]);
    // Assign the SCRIPT_URL variable
    $this->assign("ScriptURL", "http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["PHP_SELF"])."/");
    // Determine whether or not we will be debugging templates
    $this->debugging = (SITE_DEBUG == 2);
    // Set template security options
    $this->security = TRUE;
    // Disable embedded PHP
    $this->security_settings["PHP_HANDLING"] = FALSE;
    $this->security_settings["PHP_TAGS"] = FALSE;
    // Disallow including other templates
    $this->security_settings["INCLUDE_ANY"] = FALSE;
    // Disallow Smarty constants
    $this->security_settings["ALLOW_CONSTANTS"] = FALSE;
    // Disallow use of the "fetch" function
    $this->unregister_function("fetch");
  }
}

?>
