// Renders the navigation sidebar
function renderSidebar() {
  // Build the channel tree
  //buildChannelTree();
}

// Renders the main content window
function renderMain(siteName, channelName, viewName) {
  // Set the window title
  windowTitle = siteName + ": " + channelName;
  if ((channelName != viewName) && (viewName != 'Default'))
    windowTitle += " (" + viewName + ")";
  top.document.title = windowTitle;
}

// Handles attempts to log out
function logout() {
  // Create an HTTP request
  var remote = new HTTPRequest("GET", "text/plain");
  remote.url = "login.php";
  remote.queryString="logout=y&ajax=y";
  // Identify the function that will handle the response
  remote.callback = function () {
    // Check the server response
    if (remote.request.readyState == 4) {
      // If everything worked
      if (remote.request.status == 200) {
        if (browserType() == "MSIE") {
          // Reload the main window
          document.location.reload();
        }
        else {
          // Reload the main window
          document.location.reload();
        }
      }
    }
    // Otherwise, indicate the error
    else if (remote.request.readyState == 3) {
      if (remote.request.status != 200) alert(remote.request.responseText);
    }
  }  
  remote.send();
}

// Handles attempts to login
function loginWith(thisForm) {
  // Validate the login form
  if (!validateForm(thisForm)) return false;
  // Retrieve the session ID from the cookie
  session = valueOfCookie("sid");
  thisForm.elements["session"].value = session;
  // Attempt to login
  // Create an HTTP request
  var remote = new HTTPRequest("POST", "text/plain");
  // If we failed to create the request, we must do things the old-fashioned way
  if (!remote) 
    return(thisForm.submit());
  remote.url = "login.php";
  remote.queryString = encodeFormData(thisForm) + "&ajax=y";
  // Identify the function that will handle the response
  remote.callback = function() { 
    // Check the server response
    if (remote.request.readyState == 4) {
      // If everything worked
      if (remote.request.status == 200) { 
        // Hide the login form
        hideFloater("LoginForm");
        if (browserType() == "MSIE") {
         // Reload the main window
          top.document.location.reload();
        }
        else {
          // Reload the main window
          mainWindow = top.document;
          mainWindow.location.reload();
        }
      }
    }
    // Otherwise, indicate the error
    else if (remote.request.readyState == 3) {
      if (remote.request.status != 200) alert(remote.request.responseText);
    }
  } 
  // Send the request
  remote.send(); 
}

/* Submits a post */
function submitPost(thisForm, areaName, editor) {
  // Update the RTE
  updateRTE(editor);
  // Create an HTTP request
  var remote = new HTTPRequest("POST");
  // If we failed to create the request, we must do things the old-fashioned way
  if (!remote) return(thisForm.submit());
  remote.url = "postit.php";
  remote.queryString = encodeFormData(thisForm) + "&ajax=y";
  // Identify the function that will handle the response
  remote.callback = function() { 
    // Check the server response
    if (remote.request.readyState == 4) {
      // If everything worked
      if (remote.request.status == 200) {
        // Alert the user
        alert(remote.request.responseText); 
        // Reload the current page
        document.location.reload();
      }
    }
    // Otherwise, indicate the error
    else if (remote.request.readyState == 3) {
      if (remote.request.status != 200) alert(remote.request.responseText);
    }
  } 
  // Send the request
  remote.send();
} 

/* Cancels writing a post */
function cancelPost(areaName) {
  // See if the specified area name exists
  var area = document.getElementById(areaName);
  // If it does, hide it
  if (area) area.style.display = "none";
  // Otherwise, go back
  else document.history.back(1);
}

/* Edits the specified post */
function editPost(which) {
  // Show the post form
  toggleHidden('NewPost');
  // Retrieve the post title
  var postTitle = document.getElementById('post' + which + '_title');
  // Retrieve the post content
  var postContent = document.getElementById('post' + which + '_body');
  if ((!postTitle) || (!postContent)) return;
  // Set up the new post form
  var postForm = document.forms["newPost"];
  if (!postForm) return;
  var postContentFrame = frames['NewPostContent'];
  postForm.elements["action"].value = "edit";
  postForm.elements["title"].value = trim(postTitle.textContent);
  postForm.elements["id"].value = which;
  enableDesignMode('NewPostContent', postContent.innerHTML, false);
}

function newPost(element, rte) {
  // Show the post form
  toggleHidden(element);
  // Clear the post form
  enableDesignMode(rte, "", false);
}

function cancelPost(form, element, rte) {
  // Hide the post form
  toggleHidden(element);
  // Reset the post form
  form.reset();
  // Disable the rte
  disableDesignMode(rte);
}

/* Confirms the deletion of posts */
function deletePost(channel, postID) {
  // Prompt the user
  result = window.confirm("You are about to permanently delete this post.  You will not be able to recover the post if you continue.  Do you want to continue?");
  // If the user REALLY wants to delete the post, then delete it
  if (!result) return;
   // Create an HTTP request
  var remote = new HTTPRequest("POST", "text/plain");
  // If we failed to create the request, we must do things the old-fashioned way
  if (!remote) {
    document.location.href= "postit.php?action=delete&channel=" + 
      encodeURIComponent(channel) + "&id=" + postID;
    return;
  }
  remote.url = "postit.php";
  remote.queryString = "action=delete&channel=" + encodeURIComponent(channel) + 
    "&id=" + postID + "&ajax=y";
  // Identify the function that will handle the response
  remote.callback = function() { 
    // Check the server response
    if (remote.request.readyState == 4) {
      // If everything worked
      if (remote.request.status == 200) {
        // Alert the user
        alert(remote.request.responseText); 
        // Reload the current page
        document.location.reload();
      }
    }
    // Otherwise, indicate the error
    else if (remote.request.readyState == 3) {
      if (remote.request.status != 200) alert(remote.request.responseText);
    }
  } 
  // Send the request
  remote.send();
}
